/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, runOn, delegateCombine, delegateRemove, Array_$type, Number_$type, fromEnum, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
import { IDataSourceClonableDataProvider_$type } from "./IDataSourceClonableDataProvider";
import { TransactionType, TransactionType_$type } from "./TransactionType";
import { ISupportsExpansionChangeNotifications_$type } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
export let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.c2;
        }
        set dataProvider(a) {
            let b = this.c2;
            this.c2 = a;
            if (b != this.c2) {
                this.onPropertyUpdated("DataProvider", b, this.c2);
            }
        }
        get actualDataProvider() {
            if (this.c1 == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.c1;
        }
        set actualDataProvider(a) {
            let b = this.c1;
            this.c1 = a;
            if (b != this.c1) {
                this.onPropertyUpdated("ActualDataProvider", b, this.c1);
            }
        }
        get dataSource() {
            return this.d3;
        }
        set dataSource(a) {
            let b = this.d3;
            this.d3 = a;
            if (b != this.d3) {
                this.onPropertyUpdated("ItemsSource", b, this.d3);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.dataSource != null;
        }
        get c8() {
            return this.c7;
        }
        set c8(a) {
            this.c7 = a;
            {
                this.actualDataProvider = this.resolveDataProvider();
            }
        }
        constructor() {
            super();
            this.c2 = null;
            this.df = false;
            this.c1 = null;
            this.d3 = null;
            this.c7 = null;
            this.db = null;
            this.dd = null;
            this.d7 = null;
            this.c9 = null;
            this.dp = new List$1(Array_$type, 0);
            this.de = false;
            this.c0 = null;
            this.dx = -1;
            this.dq = -1;
            this.dz = -1;
            this.ds = -1;
            this.d0 = -1;
            this.dt = -1;
            this.dy = -1;
            this.dr = -1;
            this.d2 = -1;
            this.d1 = -1;
            this.dv = -1;
            this.du = -1;
            this.dw = -1;
            this.executionContext = new DataSourceExecutionContext();
            this.v.l = false;
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.df = true;
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.dataSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.db != null && this.db.a8 != null) {
                return this.db.a8.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemFromKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return a[0];
            }
            let c = this.da();
            let d;
            if (this.db != null) {
                let e = this.db.a8.count;
                for (let f = 0; f < e; f++) {
                    d = this.db.a8.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return d;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return d;
                    }
                }
                return null;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                let h = this.actualDataProvider.indexOfKey(a);
                return this.actualDataProvider.getItemAtIndex(h);
            }
            if (this.actualDataProvider != null) {
                let i = this.actualDataProvider.actualCount;
                for (let j = 0; j < i; j++) {
                    d = this.actualDataProvider.getItemAtIndex(j);
                    if (c.i(d, a) == 0) {
                        return d;
                    }
                }
            }
            return null;
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.db != null) {
                c = this.db.a8.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            if (c == null) {
                return null;
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            if (this.ar()) {
                let d = this.ao(c, b);
                if (d) {
                    let e = this.a2(c, b);
                    return e;
                }
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        c6() {
            return this.actualDataProvider;
        }
        dh() {
            return this.dp != null && this.dp.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.di() || this.dj() || this.dk() || this.dl() || this.dh()) {
                    if (this.db == null) {
                        if (this.dd == null) {
                            this.dd = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.db = new RearrangedListView(this.actualDataProvider);
                        this.db.ac = this.dd;
                        this.db.ae = new LocalDataSourceViewExpansionNotifier(this);
                        let a = this.db;
                        a.rootSummariesChanged = delegateCombine(a.rootSummariesChanged, runOn(this, this.d9));
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.db.aw = this.shouldEmitSectionHeaders && this.aq;
                    this.db.av = this.shouldEmitSectionFooters && this.aq;
                    this.db.ax = this.shouldEmitShiftedRows;
                    this.db.ay = this.shouldEmitSummaryRows;
                    this.db.ce(this.dp);
                    this.db.a4 = this.dn();
                    this.db.a3 = this.dm();
                    this.db.q = this.da();
                    this.db.af = this.groupDescriptions;
                    this.db.ag = this.sortDescriptions;
                    this.db.ah = this.summaryDescriptions;
                    this.db.m = this.summaryScope;
                    this.db.an = this.includeSummaryRowsInSection;
                    this.db.at = this.isSectionSummaryRowsAtBottom;
                    this.db.k = this.sectionHeaderDisplayMode;
                    this.db.n = this;
                    this.db.aq = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.db.u = this.dc();
                    this.db.b9();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.db.a8.count;
                }
                else {
                    let b = this.c6();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (b != null) {
                        this.actualCount = b.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.db != null) {
                        this.db.ac = null;
                        let c = this.db;
                        c.rootSummariesChanged = delegateRemove(c.rootSummariesChanged, runOn(this, this.d9));
                        this.db = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        d9(a, b) {
            this.cn();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.db != null) {
                return this.db.a8.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.dg(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        dg(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.da();
            let d;
            if (this.db != null) {
                let e = this.db.a8.count;
                for (let f = 0; f < e; f++) {
                    d = this.db.a8.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return f;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let h = this.actualDataProvider.actualCount;
                for (let i = 0; i < h; i++) {
                    d = this.actualDataProvider.getItemAtIndex(i);
                    if (c.i(d, a) == 0) {
                        return i;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.c9 = null;
        }
        da() {
            if (this.c9 != null) {
                return this.c9;
            }
            if (this.actualPrimaryKey == null) {
                this.c9 = new DataSourcePropertiesComparer(null, null, null, this);
                return this.c9;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.c9 = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.c9;
        }
        dc() {
            if (this.filterExpressions.k.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.k;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        dn() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        dm() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        dj() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        dk() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        di() {
            return this.filterExpressions != null && this.filterExpressions.k.count > 0;
        }
        dl() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.db != null) {
                this.db.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.db != null) {
                this.db.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.db != null) {
                this.db.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.db != null) {
                this.db.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        ea() {
            this.actualCount = this.db.a8.count;
            this.onBroadcastClearItems();
        }
        ed(a, b, c) {
            this.actualCount = this.db.a8.count;
            this.onBroadcastSetItem(a, b, c);
        }
        eb(a, b) {
            this.actualCount = this.db.a8.count;
            this.onBroadcastInsertItem(a, b);
        }
        ec(a, b) {
            this.actualCount = this.db.a8.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.dx = -1;
            this.dq = -1;
            if (this.db != null) {
                this.dp.add(a);
                this.db.b8(a);
            }
            else {
                this.dp.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.da();
            if (this.db != null) {
                for (let c = this.dp.count - 1; c >= 0; c--) {
                    let d = this.dp._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.dp.removeAt(c);
                        this.db.cf(d);
                    }
                }
            }
            else {
                for (let e = this.dp.count - 1; e >= 0; e--) {
                    let f = this.dp._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.dp.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.dx = -1;
            this.dq = -1;
        }
        clearPinnedRows() {
            for (let a = this.dp.count - 1; a >= 0; a--) {
                this.unpinRow(this.dp._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.db == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.da();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.dp.count; h++) {
                if (c.h(this.dp._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.de = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.de = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.de) {
                this.de = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.de = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.db == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.dh())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.db.a7.count == 1) {
                c = this.db.a7._inner[0];
                d = this.db.a7._inner[0];
            }
            else {
                c = this.db.x(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.db.a7._inner[c.z];
                    }
                }
                d = this.db.x(b);
                if (b >= this.db.a8.count - this.db.bm) {
                    d = this.db.w();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.dx && c.aa == this.dz && c.af == this.d0 && c.ad == this.dy && c.ah == this.d2 && c.ag == this.d1 && d.ae == this.dq && d.aa == this.ds && d.af == this.dt && d.ad == this.dr && d.ah == this.dv && d.ag == this.du && this.db.bm == this.dw) {
                return this.c0;
            }
            this.dx = c.ae;
            this.dq = d.ae;
            this.dz = c.aa;
            this.ds = d.aa;
            this.d0 = c.af;
            this.dt = d.af;
            this.dy = c.ad;
            this.dr = d.ad;
            this.d2 = c.ah;
            this.d1 = c.ag;
            this.dv = d.ah;
            this.du = d.ag;
            this.dw = this.db.bm;
            if (this.db.a7.count == 1) {
                this.dq = d.ad;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.aq) {
                e = 1;
            }
            let f = this.db.bc();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.db.a7._inner[h];
                let j = this.db.a7._inner[h].c.length;
                let k = this.db.a7._inner[h].v();
                if (this.shouldEmitSectionHeaders && this.aq) {
                    for (let l = 0; l < j; l++) {
                        if (this.db.a7._inner[h].a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                            if (this.summaryScope == 0 || this.summaryScope == 2) {
                                if (i.c[l] && this.includeSummaryRowsInSection && !this.isSectionSummaryRowsAtBottom) {
                                    for (let n = 0; n < f; n++) {
                                        g.add(m + 1 + n);
                                    }
                                }
                            }
                        }
                        if (!this.db.a7._inner[h].c[l]) {
                            break;
                        }
                    }
                }
                if (this.db.a7._inner[h].p) {
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < this.db.a7._inner[h].aa; o++) {
                            g.add(this.db.a7._inner[h].af + this.db.a7._inner[h].ah + o + k);
                        }
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.shouldEmitSummaryRows && this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (let p = this.db.a7._inner[h].ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(this.db.a7._inner[h].ad - k - p);
                            }
                            else {
                                g.add(this.db.a7._inner[h].ad - p);
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aq) {
                    for (let q = j - 1; q >= 0; q--) {
                        if (!this.db.a7._inner[h].c[q]) {
                            break;
                        }
                        g.add(this.db.a7._inner[h].ad - q);
                    }
                }
            }
            for (let r = this.db.a8.count - this.db.bm; r < this.db.a8.count; r++) {
                g.add(r);
            }
            this.c0 = g.toArray();
            return this.c0;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.db != null && this.db.a8.count > 0 && this.db.a8.count > a) {
                this.db.cd(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.db != null && this.db.a8.count > 0 && this.db.a8.count > a) {
                return this.db.al(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.db != null) {
                return this.db.bm;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.db != null) {
                return this.db.i;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.db != null && this.db.a7.count > 0 && a >= 0 && a < this.db.a7.count) {
                return this.db.a7._inner[a].i;
            }
            return null;
        }
        clone() {
            let a = new LocalDataSource();
            a.dataSource = this.dataSource;
            super.cloneProperties(a);
            if (this.df && this.dataProvider != null && typeCast(IDataSourceClonableDataProvider_$type, this.dataProvider) !== null) {
                a.dataProvider = this.dataProvider.clone();
            }
            return a;
        }
        ar() {
            return !this.isReadOnly && this.actualBaseDataProvider != null && this.v != null;
        }
        ct(a, b) {
            if (a == 5) {
                let c = new List$1(TransactionType_$type, 0);
                let d = new List$1(Base.$, 0);
                let e = b;
                let f = e.a;
                for (let g = 0; g < f.length; g++) {
                    if (f[g].transactionType == 1) {
                        let h = f[g].id;
                        let i = this.getItemFromKey(h);
                        if (i != null) {
                            let j = f[g].value;
                            let k = this.indexOfItem(i);
                            let l = null;
                            if (this.db != null && k > -1) {
                                l = this.db.x(k);
                                for (let m = 0; m < this.summaryDescriptions.k.count; m++) {
                                    let n = this.summaryDescriptions.k.item(m);
                                    if (n.operand == 5 || j.containsKey(n.propertyName)) {
                                        this.db.co(m, k, i, false, l);
                                    }
                                }
                            }
                            for (let o of fromEnum(j)) {
                                this.actualDataProvider.setItemValue(i, o.key, o.value);
                            }
                            if (l != null && this.db != null && k > -1) {
                                for (let p = 0; p < this.summaryDescriptions.k.count; p++) {
                                    let q = this.summaryDescriptions.k.item(p);
                                    if (q.operand == 5 || j.containsKey(q.propertyName)) {
                                        this.db.co(p, k, i, true, l);
                                    }
                                }
                            }
                            if (k > -1) {
                                this.onBroadcastSetItem(k, i, i);
                            }
                            d.add1(i);
                            c.add(1);
                            if (this.dp.count > 0) {
                                let r = this.da();
                                for (let s = 0; s < this.dp.count; s++) {
                                    if (r.h(this.dp._inner[s], h) == 0) {
                                        let t = this.getStickyRows();
                                        for (let u = 0; u < t.length; u++) {
                                            let v = t[u];
                                            let w = typeCast(DataSourceSpecialRow.$, this.db.a8.item(v));
                                            if (w != null && w.rowType == 3 && w.targetRow == i) {
                                                this.onBroadcastSetItem(v, w, w);
                                                break;
                                            }
                                        }
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    else if (f[g].transactionType == TransactionType.Delete) {
                        let x = f[g].id;
                        let y = this.indexOfKey(x);
                        if (y > -1) {
                            let z = this.getItemAtIndex(y);
                            this.actualDataProvider.removeItem(z);
                            this.notifyRemoveItem(y, z);
                            d.add1(z);
                            c.add(TransactionType.Delete);
                        }
                    }
                    else if (f[g].transactionType == 0) {
                        let aa = f[g].id;
                        let ab = aa[0];
                        if (f[g].value != null) {
                            let ac = f[g].value;
                            for (let ad of fromEnum(ac)) {
                                this.actualDataProvider.setItemValue(ab, ad.key, ad.value);
                            }
                        }
                        this.actualDataProvider.addItem(ab);
                        d.add1(ab);
                        c.add(0);
                    }
                }
                if (f.length > 0) {
                    this.b2(e.id, this.getAggregatedChanges(e.id));
                }
            }
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        notifyClearItems() {
            this.a.ea();
        }
        notifyInsertItem(a, b) {
            this.a.eb(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.ec(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.ed(a, b, c);
        }
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();
