import { IgcCaptureImageSettings } from "./igc-capture-image-settings";
export class IgcImageCapturedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the captured image as Base64.
    */
    get base64Data() {
        return this.i.base64Data;
    }
    /**
     * Gets the captured image.
    */
    get image() {
        return this.i.image;
    }
    /**
     * Gets the settings used to capture the image.
    */
    get settings() {
        const r = this.i.settings;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgcCaptureImageSettings();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
}
