import { Style as Style_internal } from "./Style";
/**
 * A class that exposes style realted properties.
*/
var IgcStyle = /** @class */ /*@__PURE__*/ (function () {
    function IgcStyle() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcStyle.prototype.createImplementation = function () {
        return new Style_internal();
    };
    Object.defineProperty(IgcStyle.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcStyle.prototype.onImplementationCreated = function () {
    };
    IgcStyle.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgcStyle.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgcStyle;
}());
export { IgcStyle };
