import { Type } from "./type";
/**
 * Describes mode for formatting date in header of data legend
 */
export declare enum DataLegendHeaderDateMode {
    /**
     * Specifies automatic date format that defaults to short string
     */
    Auto = 0,
    /**
     * Specifies date as short string in header row of data legend
     */
    ShortStyle = 1,
    /**
     * Specifies date as long string in header row of data legend
     */
    LongStyle = 2,
    /**
     * Specifies date as medium string in header row of data legend
     */
    MediumStyle = 3,
    /**
     * Specifies date as full string in header row of data legend
     */
    FullStyle = 4,
    /**
     * Specifies no date in header row of data legend
     */
    None = 5
}
/**
 * @hidden
 */
export declare let DataLegendHeaderDateMode_$type: Type;
