import { Type } from "./type";
/**
 * Enumerates the join types available to the flat data provider.
 */
export declare enum FlatDataProviderJoinCollisionType {
    /**
     * Retention is based on the join type.
     */
    Auto = 0,
    /**
     * Retains values only if they are from left.
     */
    LeftOnly = 1,
    /**
     * Retains values only if they are from right.
     */
    RightOnly = 2,
    /**
     * Prefers to retain values from left.
     */
    PreferLeft = 3,
    /**
     * Prefers to retain values from right.
     */
    PreferRight = 4
}
/**
 * @hidden
 */
export declare let FlatDataProviderJoinCollisionType_$type: Type;
