import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "./type";
import { Size } from "./Size";
import { DomRenderer, DomWrapper } from "./dom";
import { Brush } from "./Brush";
import { PopupPointerPosition } from "./PopupPointerPosition";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "./AnimationKeyFrameEffect";
import { AnimationKeyFrameEffectTiming } from "./AnimationKeyFrameEffectTiming";
import { UIElementPropertyId } from "./UIElementPropertyId";
import { Rect } from "./Rect";
import { PopupDirection } from "./PopupDirection";
import { PopupAlignment } from "./PopupAlignment";
import { PopupAnimationType } from "./PopupAnimationType";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { MouseEventArgs } from "./MouseEventArgs";
import { FocusEventArgs } from "./FocusEventArgs";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { PopupVisualModelExport } from "./PopupVisualModelExport";
import { PopupMeasuringContentSizeEventArgs } from "./PopupMeasuringContentSizeEventArgs";
/**
 * @hidden
 */
export declare class PopupView extends Base {
    static $t: Type;
    private ag;
    private f;
    private ao;
    private an;
    private am;
    private aj;
    private al;
    private ak;
    private aq;
    private get af();
    private get ac();
    private get ab();
    private get aa();
    private get ad();
    private get ae();
    private v;
    private w;
    private u;
    private m;
    private x;
    private s;
    private t;
    private q;
    private r;
    protected get g(): Popup;
    protected get ah(): DomRenderer;
    protected a6(): void;
    bn(): void;
    bl(): void;
    bm(): void;
    bo(): void;
    private a7;
    private a8;
    private a4;
    private a5;
    private o;
    private l;
    at(): void;
    au(a: Popup_OuterAnimationInfo, b: Popup_InnerAnimationInfo): {
        p0?: Popup_OuterAnimationInfo;
        p1?: Popup_InnerAnimationInfo;
    };
    av(a: number): void;
    bc(): void;
    aw(a: any): void;
    private ai;
    private ap;
    private a3;
    j(a: any): boolean;
    bb(a: any): void;
    d(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    e(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    ay(): void;
    c(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    i(): UIElementPropertyId;
    h(): UIElementPropertyId;
    private n;
    private br;
    get bs(): Size;
    private y;
    private z;
    private static as;
    private static ar;
    private bj;
    private ax;
    bq(a: Rect, b: PopupDirection, c: PopupAlignment): Rect;
    bp(a: any, b: PopupDirection, c: PopupAlignment): Rect;
    private k;
    a1(): void;
    private bd;
    a9(a: DomRenderer): void;
    private p;
    private bk;
    private bi;
    protected az(a: DomWrapper): void;
    a0(a: Popup): void;
    a2(): void;
    ba(): void;
    bg(a: boolean): void;
    bf(a: boolean): void;
    be(a: boolean): void;
    bh(a: boolean): void;
}
/**
 * @hidden
 */
export declare class Popup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private q;
    private i;
    private a2;
    private c7;
    private c5;
    private bc;
    get c8(): Rect;
    get c6(): Rect;
    get r(): PopupDirection;
    set r(a: PopupDirection);
    get j(): PopupAlignment;
    get a3(): number;
    get be(): any;
    constructor();
    onClosed: (sender: any, args: OnClosedEventArgs) => void;
    onPopup: (sender: any, args: OnPopupEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected ch(a: string, b: any, c: any): void;
    popupMouseEnter: (sender: any, args: MouseEventArgs) => void;
    popupMouseLeave: (sender: any, args: MouseEventArgs) => void;
    popupGotFocus: (sender: any, args: FocusEventArgs) => void;
    popupLostFocus: (sender: any, args: FocusEventArgs) => void;
    cf(): void;
    cg(): void;
    cc(): void;
    cd(a: any, b: any): void;
    x: PopupView;
    private ag;
    get as(): boolean;
    set as(a: boolean);
    private a8;
    get a9(): number;
    set a9(a: number);
    private al;
    get am(): boolean;
    set am(a: boolean);
    private o;
    get p(): PopupAnimationType;
    set p(a: PopupAnimationType);
    private a6;
    get bb(): number;
    set bb(a: number);
    static ba: number;
    private a5;
    get a7(): number;
    set a7(a: number);
    private aw;
    get ax(): boolean;
    static c3: Brush;
    private cu;
    get cz(): Brush;
    set cz(a: Brush);
    static c2: Brush;
    private ct;
    get cy(): Brush;
    set cy(a: Brush);
    static c1: Brush;
    private cs;
    get cx(): Brush;
    set cx(a: Brush);
    private cv;
    get c0(): Brush;
    set c0(a: Brush);
    private az;
    get a1(): number;
    set a1(a: number);
    private ah;
    get at(): boolean;
    set at(a: boolean);
    private ad;
    get ao(): boolean;
    set ao(a: boolean);
    private ai;
    get au(): boolean;
    set au(a: boolean);
    private t;
    get v(): PopupPointerPosition;
    set v(a: PopupPointerPosition);
    private cw;
    get c4(): Brush;
    set c4(a: Brush);
    private a0;
    get a4(): number;
    set a4(a: number);
    private aj;
    get av(): boolean;
    set av(a: boolean);
    private ae;
    get aq(): boolean;
    set aq(a: boolean);
    private af;
    get ar(): boolean;
    set ar(a: boolean);
    private ak;
    get ay(): boolean;
    set ay(a: boolean);
    protected w(): PopupView;
    protected ck(a: string, b: any, c: any): void;
    b3(): void;
    private aa;
    private a;
    private b;
    private c;
    private b8;
    private g;
    private h;
    ap(): boolean;
    b9(): void;
    private cj;
    private ci;
    private co;
    private cn;
    private cp;
    private k;
    private l;
    private n;
    private b5;
    private m;
    private b4;
    contains(a: any): boolean;
    appendPopupContent(a: any): void;
    removePopupContent(a: any): void;
    b6(): void;
    destroy(): void;
    showRelativeToExclusionRect(a: Rect, b: PopupDirection, c: PopupAlignment): void;
    cr(a: any, b: PopupDirection, c: PopupAlignment): void;
    ca(a: Rect): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
    bd(): any;
    bq(): string;
    d(): PopupVisualModelExport;
    u(): PopupPointerPosition;
    measuringContentSize: (sender: any, args: PopupMeasuringContentSizeEventArgs) => void;
    ce(): void;
}
